(*
  CommIntfDll - Mapovn funkc z knihovny CommIntfDll.dll
  Vytvoeno pro Delphi 7

  Vydavatel :  Papouch s.r.o. - http://www.papouch.com/
  Autor     :  Martin Zmenk zamecnik@papouch.com

  popis     : knihovna umouje komunikaci nejen se zazenmi firmy papouch s.r.o. pes sriov port, usb a ethernet (TCP nebo UDP)
              komunikan spojen se vytv pomoc funkc ciCreate a pedanho ppojovacho etzce (ten uruje, o jak rozhrann se jend, a dal parametry),
              tyto funkce vracej Handle (madlo) komunikanho rozhrann, kter se pak pedv ostatnm funkcm
              vechny funkce jsou spolen pro vechny typy rozhrann. funkce s nvratovou hodnotou reStat (integer) vracej ERR_OK (0) pokud ve problo v podku, jinak chybov kd

  Poznmky  : k pouit funkc je poteba knihovna CommIntfDll.dll,
              v ppad pouit pro USB jsou poteba t nainstalovan ovladae FTD direct drivers a knihova FTD2XX.dll, nebo nainstalovan virtuln sriov port
              
*)
unit uci_IDLLMapD;

{$DEFINE InitDLL}
interface
uses windows;
const CIDLLName = 'CommIntfDLL.dll';
type reStat = integer;
     AHandle = array of THandle;
     tSPortNumber = integer;
     TPortStateState = (PS_OPEN=0, PS_CLOSE=1, PS_NOTEXIST=2);
     TPortState = packed record
       ComNumber: tSPortNumber;
       State: TPortStateState;
     end;

const ciev_Base = $FF;  //-- Konstanty pro Typ udlosti komunikanho rozhran
      ciev_Open = ciev_Base + 1;
      ciev_Close = ciev_Base + 2;
      ciev_DataRcv = ciev_Base + 3;
      ciev_Error = ciev_Base + 4;


type

THandleNotificationEvent = procedure (Handle:THandle;Event:word;Param:word;CallBackID:cardinal);stdcall; //-- Typ callbackov funkce (viz. ciRegisterCallBackNotifications)

var
//***funkce pro sprvu chyb***
LastError : function:integer;stdcall; //-- Zjist slo posledn chyby
LastErrorText:function (Text:pchar;var Size:integer):reStat;stdcall;
                       //-- Zsk text posledn chyby. Text=buffer, do kterho bude text pedn; Size=velikost bufferu Text, zpt vrt poet znak textu.
                       //-- Pokud je Size men ne potebn velikost pro text, je nvratov hodnota ERR_MoreSize a do Size se nastav potebn velikost
                       //-- Pokud je Text NIL, pouze se do Size vrt potebn velikost bufferu pro text
                       //-- Pokud ve probhlo v podku, vrt se ERR_OK (0)
                       //-- pozn. tento princip funguje u vtiny funkc, kde se zskv textov hodnota
SetLastError:function (ErrNum:integer;Text:pchar):reStat; stdcall;
                      //-- Nastav Chybu. Pedv se slo chyby a text chyby
//*** info ***
Info:function :pChar; stdcall; //-- Vrt informan text o knihovn

//*** funkce pro prci s komunikanm rozhrannm ****
ciCreate:function (ConnectionString:pChar):THandle; stdcall; //-- Vytvo komunikan rozhrann podle zadanho pipojovacho etzce
    //--       connection string je etzec pro vytvoen komunikanho rozhrann, uruje komunikan kanl a jeho nastaven (sriov port, tcp, udp, nebo ftd_usb)
    //   Tvorba connectionstringu : jsou to hodnoty ve tvaru "parametr=hodnota" oddleny stednkem. uruj typ pipojen
    //          nejdleitjm parametrem je "provider", uruje typ rozhrann. me to bt SERIAL_PORT, TCP_CLIENT, UDP_CLIENT nebo FTD_USB
    //          kad kanl pak me mt dal parametry. SERIAL_PORT (comport=slo portu;baudrate=rychlost - nemus bt zadno), TCP_CLIENT(host=ip adresa zazen;port=tcp port zazen), UDP_CLIENT(stejn jako TCP),
    //                                                    FTD_USB(index=poadov slo zazen; nebo device=st nzvu zazen; nebo serial_number=sriov slo zazen; nebo vid=vid;pid=pid; nebo nemus mt dn parametr, vezme se prvn pipojen zazen typu FTD_USB
    //          pklady: "provider=SERIAL_PORT;comport=1", "provider=TCP_CLIENT;host=192.168.1.254;port=10001", "provider=UDP_CLIENT;host=192.168.1.254;port=10001", "provider=FTD_USB;device=Quido"
    //          Nvratov hodnota je Handle na vytvoen komunikan rozhrann. 0 = Nebylo vytvoeno

ciCreateM:function (ConnectionString:pChar;NotificationHWND:hwnd;Msg:cardinal;Blocking:boolean):THandle; stdcall;
                      //-- vytvo komunikan rozhrann viz. ciCreate, navc zaregistruje pjem udlost pomoc windows zprv.
                      //   NotificationHWND = handle okna kam maj zprvy chodit, Msg = Jak zprva se bude zaslat,
                      //   Blocking=jakou medodou budou zprvy zaslny: true-SendMessage-rozhrann ek na zpracovn udlost, false-PostMessage-rozhrann asynchronn zale upozornn o udlosti a neek na jeho zpracovn
                      //   viz. ciRegisterMsgNotifications
ciCreateCB:function (ConnectionString:pChar;CallBackEntryPoint:pointer;CallBackID:cardinal):THandle; stdcall;
                      //-- vytvo komunikan rozhrann viz. ciCreate, navc zaregistruje pjem udlost pomoc CallBackov funkce
                      //   CallBackEntryPoint = vstupn bod Callbackov funkce typu THandleNotificationEvent
                      //   CallBackID = voliteln parametr, kter bude zpt zasln pi zptnm voln (voliteln identifikace)
                      //   viz. ciRegisterCallBackNotifications
ciOpen:function (handle:THandle):reStat; stdcall; //-- oteve komunikan kanl (oteve port, nave tcp spojen, ... podle typu komunikanho rozhran; nutno ped zapoetm komunikace; vrt 0 pokud OK, chybov kd v opanm ppad
                                                  //   Jako handle se pedv handle zskan z funkc ciCreate
ciClose:function (handle:THandle):reStat; stdcall; //-- zave komunikan kanl
ciRelease:function (handle:THandle):reStat; stdcall; //-- Zru komunikan kanl a pslun handle
ciIsActive:function (handle:THandle;var Active:longbool):reStat; stdcall; //-- Zjist, zda je komunikan rozhrann oteveno. pokud je nvratov hodnota 0, do parametru Active je vrcen stav
ciRead:function (Handle:THandle;var Buffer;var Size:integer):reStat; stdcall; //-- Nate pchoz data. Size se nastav na velikost bufferu, vrti se poet natench byt
ciWrite:function (Handle:THandle;var Buffer;Size:integer):reStat; stdcall; //-- Pole data po komunikanm rozhrann
ciReadLength:function (Handle:THandle):integer; stdcall; //-- Zjist, kolik byt je ve vstupnm bufferu pipraveno k naten
ciClearReadBuffer:function(Handle:THandle):reStat; stdcall; //-- Vymae pchoz data ze vstupnho bufferu

//funkce pro usnadnn synchronn komunikace typu dotaz-odpov
ciSndGet:function(Handle:THandle;var SndBuffer;Size:integer;var RcvBytes:integer;MaxTimeOut:integer=500):reStat; stdcall;
        //-- Odele data (Size byt ze SndBufferu) a ek na odpov (Maximln MaxTimeOut milisekund). V RcvBytes vrt, kolik byt bylo pijato jako odpov. Odpov lze pijmout pomoc ciRead
ciSndGetSpinel97:function(Handle:THandle;var SndBuffer;Size:integer;var RcvBytes:integer;MaxTimeOut:integer):reStat;stdcall;
        //-- Stejn jako ciSndGet odele data a ek na odpov. Jako odpov vak oekv Spinel paket. v RcvBytes vrt poet pijatch byt platnho Spinel paketu. Pokud nebyl platn paket pijat, nvratov hodnota signalizuje chybu a RcvBytes je 0.
        //-- Odpov lze zskat funkc ciRead nebo ciReadSpin97.
ciSndGetSpin97:function (Handle:THandle;Adr:byte;Sig:byte;Inst:byte;Data:pointer;DataLen:integer;var RcvBytes:integer;MaxTimeOut:integer):reStat;stdcall;
        //-- Odele Spinelovsk paket, vytvoen parametry Adr, Sig, Inst a Data (Dlky DataLen). Zbytek spinelovsk hlaviky (prefix, dlka, CRC, ..) se vypot automaticky.
        //   Odpov jako u ciSndGetSpinel97
ciReadSpin97:function (Handle:THandle;var Adr:byte;var Sig:byte; var Ack:byte; Data:pointer; var DataSize:integer):reStat; stdcall;
        //-- Nate Spinel paket z pijatch dat. pokud v pijatch datech nen platn spinel paket, nvratov hodnota signalizuje chybu.
        //   Pokud byl pijat paket, napln se z nj hodnoty Adr, Sig a Ack a Data. v DataSize je teba zadat velikost bufferu Data, zpt se vrt aktuln velikost Dat.
ciRegisterMsgNotifications:function (Handle:THandle;WHandle:hwnd;Msg:cardinal;Blocking:longbool=true):reStat; stdcall;
                      //-- Zaregistruje pjem udlost pomoc windows zprv.
                      //   NotificationHWND = handle okna kam maj zprvy chodit, Msg = Jak zprva se bude zaslat,
                      //   Blocking=jakou medodou budou zprvy zaslny: true-SendMessage-rozhrann ek na zpracovn udlost, false-PostMessage-rozhrann asynchronn zale upozornn o udlosti a neek na jeho zpracovn
                      //   Zprva pijde ve tvaru : Msg = Msg, wParam = Handle, lParamLow = Typ udlosti (ciev_Open, ciev_Close, ciev_DataRcv, ciev_Error), lParamHi = ppadn dodaten parametr
ciUnregisterMsgNotifications:function (Handle:THandle):reStat; stdcall; //-- Odregistruje pjem udlost pomoc widnows zprv
ciRegisterCallBackNotifications:function (Handle:THandle;CallBackEntryPoint:THandleNotificationEvent;CallBackID:cardinal=0):reStat; stdcall;
                      //-- Zaregistruje pjem udlost pomoc CallBackov funkce
                      //   CallBackEntryPoint = vstupn bod Callbackov funkce typu THandleNotificationEvent
                      //   CallBackID = voliteln parametr, kter bude zpt zasln pi zptnm voln (voliteln identifikace)
                      //   Callbackov funkce je pak volna s tmito parametry : Handle-Handle rozhran;Event-typ udlosti (ciev_Open, ciev_Close, ciev_DataRcv, ciev_Error);Param-ppadn parametr; CallBackID-voliteln parametry zadan pi registraci
ciUnregisterCallBackNotifications:function (Handle:THandle):reStat; stdcall; //-- Odregistruje pjem udlost pomoc callbackov funkce
ciEnumHandles:function (HandleList:PHandle;var Size:integer):integer; stdcall; //-- Vrt seznam vech aktuln vytvoench komunikanch rozhranch
ciHandlesCount:function :integer;stdcall; //-- Vrt poet aktuln vytvoench komunikanch rozhranch
ciHandleByIndex:function (index:integer):THandle;stdcall; //-- Vrt handle podle indexu (0 .. ciHandlesCount-1)
ciGetDescription:function (Handle:THandle;Description:pChar;var Len:integer):reStat; stdcall; //-- Vrt popis komunikanho rozhran
ciGetID:function (Handle:THandle;ID:pchar;var Len:integer):reStat; stdcall; //--  Vrt textovou identifikaci rozhran
ciGetProvider: function (Handle:THandle;Provider:pChar;var Len:integer):reStat; stdcall; //-- Vrti typ rozhrann (SERIAL_PORT, TCP_CLIENT, UDP_CLIENT nebo FTD_USB)
ciGetValid:function (handle:THandle;var Valid:longbool):reStat; stdcall; //-- rezervovno
ciSetValid:function (handle:THandle;Valid:LongBool):reStat; stdcall;  //-- rezervovno
ciExecuteConfigDialog:function (handle:THandle):longbool; stdcall; //-- Spust se konfiguran dialog konkrtnho komunikanho rozhrann
ciConfigDialogAvailable:function (handle:THandle):longbool; stdcall; //-- Zjist, zda rozhran podporuje konfiguran dialog
//-------------
ciGetConfig :function (Handle:THandle;ConfigString:pChar;var Len:integer):reStat; stdcall; //-- Zsk konfiguran etzec rozhran
ciSetConfig :function (Handle:THandle;ConfigString:pChar):reStat;stdcall; //-- Nastav konfiguran etzec rozhran
ciGetConfigValue :function (Handle:THandle;ParamName:pChar;Value:pChar;var Len:integer):reStat; stdcall; //-- Zjsk jednu hodnotu z konfiguranho etzce; ParamName=nzev parametru; Value=buffer, do kterho se vrt textov podoba hodnoty
ciGetConnectionStringDlg :function (OutConnStr:pChar;var Len:integer;var OKReturn:longbool;DefaultValue:pChar=nil;Caption:pChar=nil):reStat; stdcall;
      //-- Zobraz dialog pro vytvoen konfiguranho etzce. OutConnStr = buffer pro uloen vsledku; Len = velikost bufferu OutConnStr, zpt vrt aktuln velikost etzce; OKReturn=vrt, zda bylo stisknuto OK;
      //   DefaultValue = Vchoz konfiguran etzec; Caption = Titulek okna konfiguranho etzce
//--------------

//*** funkce pro vet sriovch port a FTD USB zazen ***
EnumSerialPorts:function(Ports:PInteger;var Size:integer):integer;stdcall; //-- Vrt seznam sriovch port na potai (vetn virtulnch)
            // Ports - buffer (ukazatel na pole integer), kam se ulo vsledek; Size - velikost bufferu v bytech, zpt vrt aktuln velikost v bytech; nvratov hodnota - poet port (-1 = chyba)
SerialPortCount:function():integer;stdcall;  //-- Poet sriovch port na potai
SerialPortNumByIndex:function(index:integer):tSPortNumber;stdcall; //-- Vrt slo portu podle indexu (0..SerialPortCount-1)
SerialPortByIndex:function(index:integer;PortName:pChar;var Len:integer):reStat;stdcall; //-- Vrt nzev portu podle indexu (0..SerialPortCount-1) nap: "COM3"
GetSerialPortState:function(PortNum:tSPortNumber):TPortStateState; //-- Vrt stav sriovho portu (oteven, zaven, neexistuje)
FTDDeviceCount:function():integer;stdcall; //-- Poet zazen pipojench pes FTD USB
FTDGetDetailByIndex:function(index:integer;Flags,Typ,ID,LocID:pcardinal;SerialNum:pChar;Description:pChar):reStat;stdcall;
    //-- Zjist informace o USB zazen podle indexu (0..FTDDeviceCount-1). Flags, Typ, ID a Loc jsou ukazatele na 32bitov sla. parametry kter nechceme vrtit mou bt NIL
    //-- SerialNum a Description jsou buffery pro uloen textu, mli by bt alokovny na dostatenou velikost, nebo NIL, pokud ns nezajmaj. 32B pro SerialNum a 128B pro Description by mlo urit stait.
FTDSerNumByIndex:function(index:integer;SerNum:pChar;var Len:integer):reStat;stdcall;
    //-- Zjist sriov slo USB zazen podle indexu
FTDDevNameByIndex:function(index:integer;DevName:pChar;var Len:integer):reStat;stdcall;
    //-- Zjist nzev zazen USB zazen podle indexu
FTDVidPidByIndex:function(index:integer;var VID:integer;var PID:integer):reStat;stdcall;
    //-- Zjist VID a PID hodnoty (identifikace vrobce a produktu) USB zazen
FTDFindDevice:function(start:integer;SerNum:pChar;DevName:pChar;VID:pInteger;PID:pInteger;var Index:integer):reStat;stdcall;
    //-- Vyhled v dostupnch USB zazen na potai (prvn) ten, kter odpovd zadanm parametrm. do Index vrt jeho Index.
    //   parametry se pedvaj ukazatelem na hodnotu nebo etzec. parametry mohou bt vynechny zadnm NIL.
FTDFindDeviceCS:function(start:integer;Params:pChar;var Index:integer):reStat;stdcall;
    //-- Vyhled USB zazen podle parametr, jako FTDFindDevice, akort se parametry pedvaj v jednom etzci oddlen stednkem:
    //   Lze zadat nkter z tchto parametr:
    //   index=zad pmo index; nebo device=st nzvu zazen; nebo serial_number=sriov slo zazen; nebo vid=vid;pid=pid; nebo nemus mt dn parametr, vezme se prvn pipojen zazen typu FTD_USB)
    //   do Index se vrt Index zazen, kter odpovd vem zadanm parametrm. V ppad e tomu dn zazen neodpovd, vrt se do Index -1.
//---------
//*** pomocn funkce, ulehujc prci s nktermi importovanmi funkcemi v prosted Delphi ***
//---------
function _LastErrorText:string; //-- vrt text posledn chyby
procedure _RaiseLastError; //-- vyvol vyjmku podle posledn chyby
function _Info():string; //-- vrt informan etzec knihovny
function _ciCreate(ConnectionString:string;NotifWND:hwnd=0;NMsg:cardinal=0):THandle;  //-- Vytvor komunikan rozhran, s monost registrace udlost pomoc zprv
function _ciOpen(Handle:THandle):boolean; //-- Oteve kom. rozhran, pi selhn vyvol vyjmku
function _ciClose(Handle:THandle):boolean; //-- Zave kom. rozhran, - || -
function _ciIsActive(Handle:THandle):boolean; //-- Zjist, zda je rozhran oteveno
function _ciRead(Handle:THandle):string; //-- Nate pijat data
function _ciWrite(Handle:THandle;Data:string):boolean; //-- Zape data
function _ciEnumHandles(var HandleList:AHandle):integer; //-- Nate vechny vytvoen Handly rozhranch do pole, vrt jejich poet
function _ciGetDescription(Handle:THandle):string; //-- Vrt popis rozhran
function _ciGetID(Handle:THandle):string; //-- Vrt identifikaci rozhran
function _ciGetProvider(Handle:THandle):string; //-- Vrt providera (typ rozhran)
function _ciGetValid(handle:THandle):boolean;
procedure _ciSetValid(Handle:THandle;Valid:boolean);
function _GetConnectionStringDlg(var ConnectionString:string;Caption:string=''):boolean; //-- Zobraz dialog pro tvorbu pipojovacho etzce
function _SndRcv(Handle:THandle;const Data:string;MaxTimeOut:integer=500):string; //-- Odele data a ek na odpov. nvratov hodnota = pijat odpov
function _SndRcvSpin97(Handle:THandle;var Adr:byte;var Sig:byte;var Inst_Ack:byte;var Data:string;MaxTimeOut:integer=500):boolean;
         //-- Odele Spinel paket a pijme odpov. Vyslan paked se slo z adresy(Adr), podpisu(Sig),instrukce(Inst_Ack) a Dat(Data)
         // Pokud byla odpov pijata, nvratov hodnota je true, nastav pijt Adr, Sig a Ack (v Inst_Ack) a data se zmn na pijat Data
         // false = nebyl pijat paket zpt
//*** linkovn knihovny ***
function CIDllOK:boolean; //-- Zjist, zda byla v podku natena knihovna
function CIDllInitMsg:string; //-- Vrt chybobou zprvu, pokud nebyla v podku natena
procedure CIDTestInit;  //-- Vyvol vyjmku, pokud nebyla knihovna v podku natena



implementation
uses SysUtils,forms,messages;
var DllInited:boolean;
    hDll:THandle;
    DllInitMsg:string;

function _LastErrorText:string;
var i:integer;
begin
  CIDTestInit;
  result:='';
  LastErrorText(nil,i);
  if i>0 then
  begin
    setlength(result,i);
    LastErrorText(@result[1],i);
    setlength(result,i);
  end;
end;

procedure _RaiseLastError;
var X:integer;
begin
  CIDTestInit;
  X:=LastError;
  if X<>0 then raise Exception.Create(_LastErrorText);
end;

function _Info():string;
begin
  CIDTestInit;
  result:=Info;
end;

function _ciCreate(ConnectionString:string;NotifWND:hwnd;NMsg:cardinal):THandle;
begin
  CIDTestInit;
  result:= ciCreateM(pansichar(ConnectionString),NotifWND,NMsg,true);
  if result=0 then
   if LastError()<>0 then _RaiseLastError;
end;

function _ciOpen(Handle:THandle):boolean;
begin
  CIDTestInit;
  if ciOpen(Handle)<>0 then _RaiseLastError;
end;

function _ciClose(Handle:THandle):boolean;
begin
  CIDTestInit;
  if ciClose(Handle)<>0 then _RaiseLastError;
end;

function _ciIsActive(Handle:THandle):boolean;
var LB:LongBool;
begin
  CIDTestInit;
  if ciIsActive(Handle,LB)<>0 then _RaiseLastError;
  result:=LB;
end;

function _ciRead(Handle:THandle):string;
var i:integer;
    s:string;
begin
  CIDTestInit;
  result:='';
  i:=ciReadLength(Handle);
  if (I<0)and(LastError<>0) then _RaiseLastError;
  if i>0 then
  begin
    i:=i*2;
    setlength(S,i);
    if ciRead(Handle,s[1],i)<>0 then _RaiseLastError;
    result:=copy(s,1,i);
  end;
end;

function _ciWrite(Handle:THandle;Data:string):boolean;
var i:integer;
begin
  CIDTestInit;
  i:=length(Data);
  result:=false;
  if Data<>'' then
    result:=ciWrite(Handle,Data[1],i)<>0;
   //if ciWrite(Handle,Data[1],i)<>0 then _RaiseLastError;
end;

function _ciGetDescription(Handle:THandle):string;
var S:string;
    i:integer;
begin
  CIDTestInit;
  result:='';
  if ciGetDescription(Handle,nil,i)<>0 then _RaiseLastError;
  setlength(s,i);
  if i>0 then
  begin
    if ciGetDescription(Handle,@s[1],i)<>0 then _RaiseLastError;
    result:=copy(s,1,i);
  end;
end;

function _ciEnumHandles(var HandleList:AHandle):integer;
var x,s:integer;
begin
  CIDTestInit;
  result:=0;
  x:=ciEnumHandles(nil,s);
  if x<0 then _RaiseLastError;
  result:=x;
  if (x<=0)or(s<=0) then exit;
  setlength(HandleList, x);
  x:=ciEnumHandles(@HandleList[0],s);
  result:=x;
end;

function _ciGetID(Handle:THandle):string;
var S:string;
    i:integer;
begin
  CIDTestInit;
  result:='';
  if ciGetID(Handle,nil,i)<>0 then _RaiseLastError;
  setlength(s,i);
  if i>0 then
  begin
    if ciGetID(Handle,@s[1],i)<>0 then _RaiseLastError;
    result:=copy(s,1,i);
  end;
end;
function _ciGetProvider(Handle:THandle):string;
var S:string;
    i:integer;
begin
  CIDTestInit;
  result:='';
  if ciGetProvider(Handle,nil,i)<>0 then _RaiseLastError;
  setlength(s,i);
  if i>0 then
  begin
    if ciGetProvider(Handle,@s[1],i)<>0 then _RaiseLastError;
    result:=copy(s,1,i);
  end;
end;
function _ciGetValid(handle:THandle):boolean;
var LB:LongBool;
begin
  CIDTestInit;
  if ciGetValid(Handle,LB)<>0 then _RaiseLastError;
  result:=LB;
end;
procedure _ciSetValid(Handle:THandle;Valid:boolean);
var LB:LongBool;
begin
 CIDTestInit;
 LB:=Valid;
 if ciSetValid(Handle,LB)<>0 then _RaiseLastError;
end;
function _GetConnectionStringDlg(var ConnectionString:string;Caption:string=''):boolean;
var s,dv:string;
    L:integer;
    R:longbool;
begin
  l:=256;
  result:=false;
  setlength(s,l);
  dv:=ConnectionString;
  if ciGetConnectionStringDlg(@s[1],L,R,pansichar(DV),pansichar(Caption))=0 then
  begin
    if R then
    begin
      setlength(s,l);
      ConnectionString:=s;
      if s<>'' then result:=true;
    end;
  end else raise Exception.Create(_LastErrorText);
end;
function _SndRcv(Handle:THandle;const Data:string;MaxTimeOut:integer=500):string;
var Siz:integer;
    S:string;
begin
  result:='';
  if length(Data)<=0 then exit;
  S:=Data;
  if ciSndGet(Handle,S[1],length(S),Siz,MaxTimeOut)<>0 then exit;
  if Siz<=0 then exit;
  setlength(S,Siz);
  if ciRead(Handle,S[1],Siz)<>0 then exit;
  setlength(S,Siz);
  result:=S;
end;

function _SndRcvSpin97(Handle:THandle;var Adr:byte;var Sig:byte;var Inst_Ack:byte;var Data:string;MaxTimeOut:integer):boolean;
var Siz:integer;
    S:string;
    P:pointer;
begin
  result:=false;
  if length(Data)<=0 then P:=nil else P:=@Data[1];
  if ciSndGetSpin97(Handle,Adr,Sig,Inst_Ack,P,length(Data),Siz,MaxTimeOut)<>0 then exit;
  if Siz<=0 then exit;
  setlength(S,Siz);
  if ciReadSpin97(Handle,Adr,Sig,Inst_Ack,@S[1],Siz)<> 0 then exit;
  setlength(S,Siz);
  Data:=S;
  result:=true;
end;

function CIDllInitMsg:string;
begin
  if CIDllOK then result:='' else result:=DllInitMsg;
end;

procedure CIDTestInit;
begin
  if not cidllok then raise Exception.Create(DllInitMsg);
end;

function CIDllOK:boolean;
{}procedure Map(var ProcAddr:Pointer;const Name:string);
{}begin
    ProcAddr:=GetProcAddress(hDll,pansichar(Name));
    if not assigned(ProcAddr) then raise Exception.Create('Can not map function '+Name+ ' in '+cidllname);
{}end;
begin
  if DllInited then
  begin
    result:=(hDLL<>0);
  end else
  begin
    try
      DllInited:=true;
      result:=false;
      dllinitmsg:='';
      hDLL := LoadLibrary(pansichar(cidllname));
      if hDLL=0 then
      begin
        DllInitMsg := 'Can''t load library '+CIDLLName + '.';
        exit;
      end;
      Map(@ciCreate,'ciCreate');
      Map(@ciCreateM,'ciCreateM');
      Map(@ciCreateCB,'ciCreateCB');
      Map(@ciOpen ,'ciOpen');
      Map(@ciClose ,'ciClose');
      Map(@ciRelease,'ciRelease');
      Map(@ciIsActive,'ciIsActive');
      Map(@ciRead ,'ciRead');
      Map(@ciWrite ,'ciWrite');
      Map(@ciReadLength ,'ciReadLength');
      Map(@ciRegisterMsgNotifications ,'ciRegisterMsgNotifications');
      Map(@ciUnregisterMsgNotifications ,'ciUnregisterMsgNotifications');
      Map(@ciRegisterCallBackNotifications ,'ciRegisterCallBackNotifications');
      Map(@ciUnregisterCallBackNotifications ,'ciUnregisterCallBackNotifications');
      Map(@ciEnumHandles,'ciEnumHandles');
      Map(@ciGetDescription ,'ciGetDescription');
      Map(@ciGetID,'ciGetID');
      Map(@ciGetValid ,'ciGetValid');
      Map(@ciExecuteConfigDialog ,'ciExecuteConfigDialog');
      Map(@ciConfigDialogAvailable,'ciConfigDialogAvailable');
      Map(@ciHandlesCount,'ciHandlesCount');
      Map(@ciHandleByIndex,'ciHandleByIndex');
      Map(@ciGetProvider,'ciGetProvider');
      Map(@LastError,'LastError');
      Map(@LastErrorText,'LastErrorText');
      Map(@SetLastError,'SetLastError');
      //---------------------
      Map(@EnumSerialPorts,'EnumSerialPorts');
      Map(@SerialPortCount,'SerialPortCount');
      Map(@SerialPortNumByIndex,'SerialPortNumByIndex');
      Map(@SerialPortByIndex,'SerialPortByIndex');
      Map(@GetSerialPortState,'GetSerialPortState');
      Map(@FTDDeviceCount,'FTDDeviceCount');
      Map(@FTDGetDetailByIndex,'FTDGetDetailByIndex');
      Map(@FTDSerNumByIndex,'FTDSerNumByIndex');
      Map(@FTDDevNameByIndex,'FTDDevNameByIndex');
      Map(@FTDVidPidByIndex,'FTDVidPidByIndex');
      Map(@FTDFindDevice,'FTDFindDevice');
      Map(@FTDFindDeviceCS,'FTDFindDeviceCS');
      //---------------------
      Map(@ciGetConfig,'ciGetConfig');
      Map(@ciSetConfig,'ciSetConfig');
      Map(@ciGetConfigValue,'ciGetConfigValue');
      Map(@ciGetConnectionStringDlg,'ciGetConnectionStringDlg');

      Map(@ciClearReadBuffer,'ciClearReadBuffer');
      Map(@ciSndGet,'ciSndGet');
      Map(@ciSndGetSpinel97,'ciSndGetSpinel97');
      Map(@ciSndGetSpin97,'ciSndGetSpin97');
      Map(@ciReadSpin97,'ciReadSpin97');
      
      //Map(@,'');
      //Map(@ci,'ci');
      result:=true;
    except
      on e:exception do
      begin
        if hDll<>0 then
        begin
           FreeLibrary(hDLL);
           hDll := 0;
        end;
        DllInitMsg := e.Message;
      end;
    end;
  end;
end;

initialization
 DllInited := false;
 hDll := 0;
 {$IFDEF InitDLL}
 if not CIDllOK then
  if MessageBox(0,pansichar(DllInitMsg+#13#10+'Terminate aplication?'),'Error in loading library',MB_YESNO+MB_ICONERROR)=IDYes
    then PostMessage(Application.Handle,WM_QUIT,0,0);
 {$ENDIF}
finalization
 if hDLL<>0 then FreeLibrary(hDll);
 hDll:=0;
end.